#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;

using namespace std;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back
const int p = 211;
const int mod = 1e9 + 7;
vi P;
struct rel {
    vi pipka;
    int n;
    rel(vi a) {
        n = a.size();
        pipka.resize(a.size() + 1);
        pipka[0] = 0;
        for (int i = 0; i < n; ++i) {
            pipka[i + 1] = (pipka[i] * p + a[i]) % mod;
        }
    }
    int get(int l, int r) {
        int x = pipka[r + 1] - pipka[l] * P[r - l + 1] % mod;
        while (x < 0)
            x += mod;
        return x;
    }
};

vi precalc;

void solve() {
    int n, m;
    cin >> n >> m;
    precalc.resize(2e5);
    precalc[0] = 1;
    for (int i = 1; i < 2e5; ++i) {
        precalc[i] = (precalc[i - 1] * p + 103) % mod;
    }
    P.resize(2e5);
    P[0] = 1;
    for (int i = 1; i < 2e5; ++i) {
        P[i] = P[i - 1] * p % mod;
    }
    vi a(n);
    for (auto &i : a) {
        cin >> i;
        i += 103;
    }
    vi b(m);
    for (auto &i : b) {
        cin >> i;
        i += 103;
    }
    rel ma(a), mb(b);
    vi _rev_a = a, _rev_b = b;
    reverse(_rev_a.begin(), _rev_a.end());
    reverse(_rev_b.begin(), _rev_b.end());
    rel ra(_rev_a), rb(_rev_b);
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            int len = j - i;
            if (i - len < 0)
                continue;
            for (int k = 0; k < m; ++k) {
                if (k + len >= n || k - len < 0)
                    continue;
                int x = 0, y = 0;
                x = ma.get(i, j);
                x -= ra.get(n - i - 1, n - i - 1 + len);
                y = mb.get(k, k + len);
                y -= rb.get(m - k - 1, m - k - 1 + len);
                x += precalc[len + 1];
                y += precalc[len + 1];
                x = (x % mod + mod) % mod;
                y = (y % mod + mod) % mod;
                if (x == y) {
                    ans = max(ans, len * 2 + 1);
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            int len = j - i;
            if (i - len - 1 < 0)
                continue;
            for (int k = 0; k < m; ++k) {
                if (k + len >= n || k - len - 1 < 0)
                    continue;
                int x = 0, y = 0;
                x = ma.get(i, j);
                x -= ra.get(n - i, n - i + len);
                y = mb.get(k, k + len);
                y -= rb.get(m - k, m - k + len);
                x += precalc[len + 1];
                y += precalc[len + 1];
                x = (x % mod + mod) % mod;
                y = (y % mod + mod) % mod;
                if (x == y) {
                    ans = max(ans, (len + 1) * 2);
                }
            }
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
