#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;

using namespace std;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back
const int p = 107;
const int mod = 1e9 + 7;
vi P;
struct rel {
    vi pipka;
    int n;
    rel(vi a) {
        n = a.size();
        pipka.resize(a.size() + 1);
        pipka[0] = 0;
        for (int i = 0; i < n; ++i) {
            pipka[i + 1] = (pipka[i] * p + a[i]) % mod;
        }
    }
    int get(int l, int r) {
        int x = pipka[r + 1] - pipka[l] * P[r - l + 1] % mod;
        while (x < 0)
            x += mod;
        return x;
    }
};

vi precalc;
vi get_magic(int n, int cool, int cf, rel &ma, rel &ra, vi &a) {
    vi ind;
    for (int i = 0; i < n; ++i) {
        ind.pb(i);
    }
    sort(ind.begin(), ind.end(), [&] (int l, int r) {
        int L = -1, R = min({n - l - 1, n - r - 1, l - cool, r - cool});
        if (R == -1)
            return l < r;
        while (R - L + 1) {
            int mid = (L + R) / 2;
            int x = 0;
            x += ma.get(l, l + mid) * cf;
            x -= ra.get(n - l - 1 + cool, n - l - 1 + cool + mid) * cf;
            int y = 0;
            y += ma.get(r, r + mid) * cf;
            y -= ra.get(n - r - 1 + cool, n - r - 1 + cool + mid) * cf;
            x += precalc[mid + 1];
            y += precalc[mid + 1];
            x = (x % mod + mod) % mod;
            y = (y % mod + mod) % mod;
            if (x == y)
                L = mid;
            else
                R = mid;
        }
        int lx = (a[l + R] - a[l - R - cool]) * cf;
        int rx = (a[r + R] - a[r - R - cool]) * cf;
        return lx < rx;
    });
    return ind;
}

void solve() {
    int n, m;
    cin >> n >> m;
    precalc.resize(2e5);
    precalc[0] = 0;
    for (int i = 1; i < 2e5; ++i) {
        precalc[i] = (precalc[i - 1] * p + 0) % mod;
    }
    P.resize(2e5);
    P[0] = 1;
    for (int i = 1; i < 2e5; ++i) {
        P[i] = P[i - 1] * p % mod;
    }
    vi a(n);
    for (auto &i : a) {
        cin >> i;
//        i += 103;
    }
    vi b(m);
    for (auto &i : b) {
        cin >> i;
//        i += 103;
    }
    rel ma(a), mb(b);
    vi _rev_a = a, _rev_b = b;
    reverse(_rev_a.begin(), _rev_a.end());
    reverse(_rev_b.begin(), _rev_b.end());
    rel ra(_rev_a), rb(_rev_b);
//    vi maga0 = get_magic(n, 0, 1, ma, ra, a);
//    vi magb0 = get_magic(n, 0, -1, mb, rb, b);
//    vi maga1 = get_magic(n, 1, 1, ma, ra, a);
//    vi magb1 = get_magic(n, 1, -1, mb, rb, b);
    int ans = 1;
    int l = -1, r = min(n, m) + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if ((mid * 2) + 1 > min(n, m)) {
            r = mid;
            continue;
        }
        vi A, B;
        for (int i = 0; i < n; ++i) {
            if (i - mid >= 0 && i + mid < n) {
                int x = ra.get(i, i + mid);
                x -= ma.get(n - i - 1, n - i - 1 + mid);
                x += precalc[mid + 1];
                x = (x % mod + mod) % mod;
                A.pb(x);
            }
        }
        for (int i = 0; i < m; ++i) {
            if (i - mid >= 0 && i + mid < m) {
                int x = -rb.get(i, i + mid);
                x += mb.get(m - i - 1, m - i - 1 + mid);
                x += precalc[mid + 1];
                x = (x % mod + mod) % mod;
                B.pb(x);
            }
        }
        sort(A.begin(), A.end());
        sort(B.begin(), B.end());
        int it = 0;
        bool ok = 0;
        for (int i = 0; i < A.size(); ++i) {
            while (it < B.size() && B[it] < A[i]) {
                it++;
            }
            if (it < B.size() && B[it] == A[i]) {
                ok = 1;
                break;
            }
        }
        if (ok)
            l = mid;
        else
            r = mid;


    }
    ans = max(ans, l * 2 + 1);
    l = -1, r = min(n, m) + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if ((mid + 1) * 2 > min(n, m)) {
            r = mid;
            continue;
        }
        vi A, B;
        for (int i = 0; i < n; ++i) {
            if (i - mid - 1 >= 0 && i + mid < n) {
                int x = ra.get(i, i + mid);
                x -= ma.get(n - i, n - i + mid);
                x += precalc[mid + 1];
                x = (x % mod + mod) % mod;
                A.pb(x);
            }
        }
        for (int i = 0; i < m; ++i) {
            if (i - mid - 1 >= 0 && i + mid < m) {
                int x = -rb.get(i, i + mid);
                x += mb.get(m - i, m - i + mid);
                x += precalc[mid + 1];
                x = (x % mod + mod) % mod;
                B.pb(x);
            }
        }
        sort(A.begin(), A.end());
        sort(B.begin(), B.end());
        int it = 0;
        bool ok = 0;
        for (int i = 0; i < A.size(); ++i) {
            while (it < B.size() && B[it] < A[i]) {
                it++;
            }
            if (it < B.size() && B[it] == A[i]) {
                ok = 1;
                break;
            }
        }
        if (ok)
            l = mid;
        else
            r = mid;
    }
    ans = max(ans, (l + 1) * 2);
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
