#include <bits/stdc++.h>

typedef long long ll;
typedef double ld;

using namespace std;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const ld pi = acos(-1);

void solve() {
    int n, k;
    cin >> n >> k;
    int a[n];
    for (auto &i : a)
        cin >> i;
    vector<pii> b;
    for (int i = 0; i < n; ++i)
        b.pb({a[i], i});

    if (k == 0) {
        auto f = [&](pii x, int kekw) {
            int cnt[n];
            int sum[n];
            int mx = 0;
            int it = 0;
            int _c = 0, _s = 0;
            int ans = -1e18;
            for (int i = 0; i < n; ++i) {
                if (make_pair(a[i], i) >= x) {
                    _c++;
                } else {
                    _s += a[i];
                }
                cnt[i] = _c;
                sum[i] = _s;
                while (it < i && cnt[i] - cnt[it] >= k) {
                    mx = min(mx, sum[it]);
                    it++;
                }
                if (cnt[i] >= k && (kekw == -1 || i == kekw)) {
                    ans = max(ans, sum[i] - mx);
                }
            }
//        cout << x.f << ' ' << x.s << ' ' << ans << endl;
            return ans;
        };
        cout << f({1e10, 1e10}, -1) << endl;
        exit(0);
    }
    int pr[n];
    for (int i = 0; i < n; ++i) {
        pr[i] = a[i];
        if (i)
            pr[i] += pr[i - 1];
    }
    auto comb = [&] (pii a, pii b) -> pii {
        return {max(a.f, b.f), min(a.s, b.s)};
    };
    int st[n + 5];
    int _st = 0;
    for (int i = 0; i < n + 5; ++i) {
        while ((1 << _st + 1) <= i) {
            _st++;
        }
        st[i] = _st;
    }
    pii sparse[n][19];
    for (int i = n - 1; i >= 0; --i) {
        sparse[i][0] = {pr[i], pr[i]};
        for (int j = 1; j < 19; ++j) {
            sparse[i][j] = comb(sparse[i][j - 1], sparse[min(n - 1, i + (1 << j - 1))][j - 1]);
        }
    }
    auto get = [&] (int l, int r) {
        if (l > r)
            return 0LL;
//        cout << "GET_S" << ' ' << l << ' ' << r << ' ' << pr[r] - (l ? pr[l - 1] : 0) << endl;
        return pr[r] - (l ? pr[l - 1] : 0);
    };
    auto get_sp = [&] (int l, int r) {
        if (l == -1) {
            l++;
            int k = st[r - l + 1];
            return comb(comb(sparse[l][k], sparse[r - (1 << k) + 1][k]), {0, 0});
        }
        int k = st[r - l + 1];
        return comb(sparse[l][k], sparse[r - (1 << k) + 1][k]);
    };
    int ans = 0;
    set<int> s;
    sort(b.rbegin(), b.rend());
     for (int i = 0; i < n; ++i) {
        s.insert(b[i].s);
        auto it = s.find(i);
        int cnt = 0;
        deque<int> d;
        for (auto j = it; j != s.end() && cnt <= k + 3; j++, cnt++) {
            d.pb(*j);
        }
        cnt = 0;
        if (it != s.begin()) {
            for (auto j = prev(it); cnt <= k + 3; cnt++) {
                d.push_front(*j);
                if (j == s.begin()) {
                    break;
                }
                j--;
            }
        }
        if (cnt <= k + 3) {
            d.push_front(-1);
        }
        int lans = 0;
        int sum = 0;
        for (int i = 1; i < d.size() - 1; ++i) {
//            cout << k << endl;
            sum += get(d[i - 1] + 1, d[i] - 1);
            if (i - k >= 0) {
                sum -= get(d[i - k] + 1, d[i - k + 1] - 1);
            }
            int l = i - k + 1, r = i;
            int sl = 0, sr = 0;
            if (l > 0 && d[l]) {
//                cout << "SL " << pr[d[l] - 1] << ' ' << get_sp(d[l - 1], d[l] - 1).s << endl;
                sl = pr[d[l] - 1] - get_sp(d[l - 1], d[l] - 1).s;
            }
            if (r + 1 < d.size()) {
                sr = -pr[d[r]] + get_sp(d[r], d[r + 1] - 1).f;
            }
//            cout << d[i] << ' ' << sl << ' ' << sum << ' ' << sr << endl;
            if (i >= k)
                lans = max(lans, sum + sl + sr);
        }
//        cout << i << ' ' << lans << endl;
        ans = max(ans, lans);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}