#include <bits/stdc++.h>

typedef long long ll;
typedef double ld;

using namespace std;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const ld pi = acos(-1);

const int maxn = 1e5 + 50;
vector<pii > r[maxn];
pii dp[maxn][2];

pii comb(pii a, pii b) {
    if (a.f == b.f)
        return min(a, b);
    return max(a, b);
}

pii merge(pii a, pii b) {
    return {a.f + b.f, a.s + b.s};
}

int ves[maxn];

int K;

void dfs(int v, int p = -1) {
    vector<int> k;
    for (auto &[u, w]: r[v]) {
        if (u != p) {
            ves[u] = w;
            dfs(u, v);
            k.pb(u);
        }
    }
    if (k.size() == 0) {
        dp[v][0] = {0, 0};
        if (K > 1)
            dp[v][1] = {0, 0};
    } else {
        int m = k.size();
        pii ldp[m + 1][K + 1];
        for (auto &i: ldp) for (auto &j: i) j = {-1e9, 1e9};
        ldp[0][0] = {0, 0};
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j <= K; ++j) {

                ldp[i + 1][j] = comb(ldp[i + 1][j], merge(ldp[i][j], dp[k[i]][0]));
                if (j < K) {
                    ldp[i + 1][j + 1] = comb(ldp[i + 1][j + 1],
                                             merge(merge(ldp[i][j], dp[k[i]][1]), {1, ves[k[i]]}));
                }
            }
        }
        for (int i = 0; i <= K; ++i) {
            if (i < K) {
                dp[v][1] = comb(dp[v][1], ldp[m][i]);
            } else {
                dp[v][0] = comb(dp[v][0], ldp[m][i]);
            }

        }

    }
}

void solve() {
    int n;
    cin >> n >> K;
    for (int i = 0; i < n; ++i) {
        dp[i][0] = dp[i][1] = {-1e9, 1e9};
    }
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        p--;
        r[p].pb({i, w});
    }
    dfs(0);
//    for (int i = 0; i < n; ++i) {
//        cout << dp[i][0].f << ' ' << dp[i][1].f << endl;
//    }
    pii ans = comb(dp[0][0], dp[0][1]);
    cout << ans.f << ' ' << ans.s << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}